#include <semaphore.h>
#include <unistd.h>
#include "list.hpp"    // list implementation
#include "globals.hpp" // lists, sems, muts
#include "producer.hpp"

void produce(block* b);

void *producer (void *) {
   block *b;
   while (true) {
      // wait for >1 block on freelist
      wait(sem_freelist_minus_1);
      // wait for element on freelist
      wait(sem_freelist);
      // mutual exclusion for freelist
      wait(mut_freelist);
      //* b:= unlink(freelist);
      b = unlink(freelist);
      // mutual exclusion for freelist
      signal(mut_freelist);

      //* produce_information_in_block(b)
      produce(b);

      // mutual exclusion for list1
      wait(mut_list1);
      //* link(b, list1);
      link(b, list1);
      // mutual exclusion for list1
      signal(mut_list1);
      // signal new element on list1
      signal(sem_list1);
   }
   return nullptr;
}

void produce(block *b) {
   return;
}
